SystemOrganization addCategory: #ImageFootprint!

!MethodReference methodsFor: '*ImageFootprint' stamp: 'hjo 3/27/2009 10:54'!
isReal

	"Is this really a method that can be called? Unlike #DoIt."
	^self actualClass canUnderstand: self methodSymbol! !

Object subclass: #ImageFootprint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFootprint'!

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 3/27/2009 12:31'!
dumpClasses

	FileStream newFileNamed: self fileStem , '.classDump' do: 
		[:stream|
			'Printing classes'
				displayProgressAt: Sensor cursorPoint for: (Smalltalk allClasses sortBy: #name ascendingSortBlock) do: [:c| stream nextPutAll: (c definition copyWithoutAll: String crlf) ; cr ] 
		].

! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 3/27/2009 12:32'!
dumpMethods

	| cm |
	FileStream newFileNamed: self fileStem , '.methodDump' do: 
	[:stream|
		'Printing methods'
				displayProgressAt: Sensor cursorPoint for: ((CompiledMethod allInstances collect: [:e| e methodReference ]) reject: [:each| each isNil]) asSortedCollection 
 		do: [:m| |vs| vs:= m stringVersion.
			vs isNil ifTrue: [ vs:= m stringVersionDefault ].
			vs notNil ifTrue: [
				m isReal
					ifTrue: [
						cm := m compiledMethod.
						stream nextPutAll: vs; nextPutAll: '    ----'; nextPutAll: cm timeStamp; cr]] ]
	].

! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 3/27/2009 10:58'!
fileStem

	^FileDirectory baseNameFor: (FileDirectory localNameFor: SmalltalkImage current imageName)! !

!ImageFootprint methodsFor: 'as yet unclassified' stamp: 'hjo 3/27/2009 10:42'!
go

	self dumpClasses.
	self dumpMethods.
	self beep: 'croak'
! !
